diff -rupN d:\t052/src/game/client/components/items.cpp d:\eg/src/game/client/components/items.cpp
--- d:\t052/src/game/client/components/items.cpp	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/game/client/components/items.cpp	2010-02-04 10:53:13.000000000 +0100
@@ -3,21 +3,29 @@
 #include <game/generated/gc_data.hpp>
 
 #include <game/gamecore.hpp> // get_angle
+#include <game/collision.hpp>
+
 #include <game/client/gameclient.hpp>
 #include <game/client/ui.hpp>
 #include <game/client/render.hpp>
 
+#include <math.h>
+
+#include <game/client/components/players.hpp>
+#include <game/client/components/controls.hpp>
 #include <game/client/components/flow.hpp>
 #include <game/client/components/effects.hpp>
+#include <game/client/components/particles.hpp>
+
+#include <game/server/entities/vortex.hpp>
 
 #include "items.hpp"
 
 void ITEMS::render_projectile(const NETOBJ_PROJECTILE *current, int itemid)
 {
-
 	// get positions
-	float curvature = 0;
 	float speed = 0;
+	float curvature = 0;
 	if(current->type == WEAPON_GRENADE)
 	{
 		curvature = gameclient.tuning.grenade_curvature;
@@ -33,9 +41,14 @@ void ITEMS::render_projectile(const NETO
 		curvature = gameclient.tuning.gun_curvature;
 		speed = gameclient.tuning.gun_speed;
 	}
+	else if(current->type == WEAPON_BIORIFLE)
+	{
+		curvature = gameclient.tuning.biorifle_curvature;
+		speed = gameclient.tuning.biorifle_speed;
+	}
 
 	float ct = (client_prevtick()-current->start_tick)/(float)SERVER_TICK_SPEED + client_ticktime();
-	if(ct < 0)
+	if(ct < 0 && current->type != WEAPON_BIORIFLE)
 		return; // projectile havn't been shot yet
 		
 	vec2 startpos(current->x, current->y);
@@ -44,13 +57,16 @@ void ITEMS::render_projectile(const NETO
 	vec2 prevpos = calc_pos(startpos, startvel, curvature, speed, ct-0.001f);
 
 
-	gfx_texture_set(data->images[IMAGE_GAME].id);
+	if (current->type == WEAPON_BIORIFLE)
+		gfx_texture_set(data->images[IMAGE_EGAME].id);
+	else
+		gfx_texture_set(data->images[IMAGE_GAME].id);
 	gfx_quads_begin();
 	
 	select_sprite(data->weapons.id[clamp(current->type, 0, NUM_WEAPONS-1)].sprite_proj);
 	vec2 vel = pos-prevpos;
 	//vec2 pos = mix(vec2(prev->x, prev->y), vec2(current->x, current->y), client_intratick());
-	
+	float size = 32;
 
 	// add particle for this projectile
 	if(current->type == WEAPON_GRENADE)
@@ -59,26 +75,100 @@ void ITEMS::render_projectile(const NETO
 		gameclient.flow->add(pos, vel*1000*client_frametime(), 10.0f);
 		gfx_quads_setrotation(client_localtime()*pi*2*2 + itemid);
 	}
-	else
+	else if(current->type != WEAPON_BIORIFLE)
 	{
 		gameclient.effects->bullettrail(pos);
 		gameclient.flow->add(pos, vel*1000*client_frametime(), 10.0f);
-
+	
 		if(length(vel) > 0.00001f)
 			gfx_quads_setrotation(get_angle(vel));
-		else
-			gfx_quads_setrotation(0);
+		else {
+			gfx_quads_setrotation(0);			
+		}
 
+	} 
+	else if(current->type == WEAPON_BIORIFLE)
+	{
+		{
+			PARTICLE p;
+			p.set_default();
+			p.spr = SPRITE_PART_SMOKE;
+			p.pos = pos;
+			if (length(vel) > 0.00001f) {
+				p.vel = vel*100;
+				p.start_size = 12.0f + frandom()*8;
+				p.gravity = frandom()*500.0f;
+			}
+			else 
+			{
+				p.vel = vec2(get_dir(client_localtime()*10))*80;
+				p.gravity = 0;
+			}
+			p.start_size = 8.0f + frandom()*4;
+			p.life_span = 0.1 + frandom()*0.3f;		
+			p.end_size = 0;
+			p.friction = 1;
+			
+			p.color = vec4(0.75f,0.15f,0.85f,1.0f);
+			p.flow_affected = 0;
+			if(length(vel) > 0.00001f)
+				p.gravity *= 2;
+			gameclient.particles->add(PARTICLES::GROUP_PROJECTILE_TRAIL, &p);					
+		}
+				
+		gfx_setcolor(0.8, 0.1, 0.9, 1);
+		if(length(vel) <= 0.00001f) {
+			gfx_setcolor(0.8, 0.1, 0.9, cosf(client_localtime()*20)/2+1);		
+			select_sprite(SPRITE_WEAPON_SPINGUN_HALO);
+			size = size + 10 * cosf(client_localtime()*5);
+		} 
+		else {
+			gfx_quads_setrotation(get_angle(vel));
+		}
 	}
 
-	gfx_quads_draw(pos.x, pos.y, 32, 32);
+	gfx_quads_draw(pos.x, pos.y, size, size);
+	gfx_quads_setrotation(0);
+	gfx_quads_end();
+}
+
+void ITEMS::render_DROPPEDWEAPON(const NETOBJ_DROPPED_WEAPON *current)
+{
+	float size = 64.0f;
+	float ct = (client_prevtick()-current->start_tick)/(float)SERVER_TICK_SPEED + client_ticktime();
+	float curvature = gameclient.tuning.droppedweapon_curvature;
+	float speed = gameclient.tuning.droppedweapon_speed;
+	
+	if(current->subtype >WEAPON_RIFLE)
+		gfx_texture_set(data->images[IMAGE_EGAME].id);
+	else
+		gfx_texture_set(data->images[IMAGE_GAME].id);
+	
+	gfx_quads_begin();
+	select_sprite(data->weapons.id[clamp(current->subtype, 0, NUM_WEAPONS-1)].sprite_body);
+	size = data->weapons.id[clamp(current->subtype, 0, NUM_WEAPONS-1)].visual_size;
+	
+	vec2 startpos(current->x, current->y);
+	vec2 startvel(current->vx/100.0f, current->vy/100.0f);
+	vec2 pos = calc_pos(startpos, startvel, curvature, speed, ct);
+	vec2 prevpos = calc_pos(startpos, startvel, curvature, speed, ct-0.001f);
+	
 	gfx_quads_setrotation(0);
+	float offset = pos.y/32.0f + pos.x/32.0f;
+	pos.x += cosf(client_localtime()*2.0f+offset)*2.5f;
+	pos.y += sinf(client_localtime()*2.0f+offset)*2.5f;
+	draw_sprite(pos.x, pos.y, size);
 	gfx_quads_end();
 }
 
 void ITEMS::render_pickup(const NETOBJ_PICKUP *prev, const NETOBJ_PICKUP *current)
 {
-	gfx_texture_set(data->images[IMAGE_GAME].id);
+	if ((current->type == POWERUP_WEAPON && (current->subtype >WEAPON_RIFLE && current->subtype != WEAPON_NINJA))
+	|| (current->type == POWERUP_SPECIAL && current->subtype != SPECIAL_NINJAPWR && current->subtype != SPECIAL_YELLOWARMOR))
+		gfx_texture_set(data->images[IMAGE_EGAME].id);
+	else
+		gfx_texture_set(data->images[IMAGE_GAME].id);
+	
 	gfx_quads_begin();
 	vec2 pos = mix(vec2(prev->x, prev->y), vec2(current->x, current->y), client_intratick());
 	float angle = 0.0f;
@@ -89,23 +179,32 @@ void ITEMS::render_pickup(const NETOBJ_P
 		select_sprite(data->weapons.id[clamp(current->subtype, 0, NUM_WEAPONS-1)].sprite_body);
 		size = data->weapons.id[clamp(current->subtype, 0, NUM_WEAPONS-1)].visual_size;
 	}
-	else
+	else if (current->type == POWERUP_SPECIAL)
 	{
 		const int c[] = {
-			SPRITE_PICKUP_HEALTH,
-			SPRITE_PICKUP_ARMOR,
-			SPRITE_PICKUP_WEAPON,
-			SPRITE_PICKUP_NINJA
+			0,
+			SPRITE_HEALTH_OVERFILL,
+			SPRITE_ARMOR_FULL,
+			SPRITE_ARMOR_OVERFILL,
+			SPRITE_HOOK_CHAIN,
+			SPRITE_PICKUP_NINJA,
+			SPRITE_HOOK_HEAD,
 			};
-		select_sprite(c[current->type]);
-
-		if(c[current->type] == SPRITE_PICKUP_NINJA)
-		{
+			select_sprite(c[current->subtype]);
+		
 			gameclient.effects->powerupshine(pos, vec2(96,18));
 			size *= 2.0f;
 			pos.x += 10.0f;
-		}
 	}
+	else
+	{
+		const int c[] = {
+			SPRITE_PICKUP_HEALTH,
+			SPRITE_PICKUP_ARMOR,
+			};
+			select_sprite(c[current->type]);
+	}
+
 
 	gfx_quads_setrotation(angle);
 
@@ -146,71 +245,251 @@ void ITEMS::render_flag(const NETOBJ_FLA
 	gfx_quads_end();
 }
 
+void ITEMS::render_shaft_beam(const struct NETOBJ_SHAFT_BEAM *current) {
+		vec2 pos = vec2(current->x, current->y);
+		vec2 from = PLAYERS::get_intratick_pos(current->playerID);
+		vec2 dir = normalize(pos-from);
+		float dist = length(pos-from);
+		
+	
+		// beam is from local player? use local (more precise) coords then
+		if (current->playerID == gameclient.snap.local_cid) {
+			from = gameclient.predicted_char.pos;
+			// get the intersecting position TODO: get this from the /server/character's activesparkle somehow...			
+			//pos = (from + normalize(pos-from)*tuning.shaft_range);
+			//col_intersect_line(from, pos, &pos, 0x0);
+			pos = gameclient.controls->target_pos;
+			// approximate by length of ray from "unprecise" ray
+			dir = normalize(pos-from);
+			pos = from + (dir*dist);
+		}
+		dist = length(pos-from);
 
-void ITEMS::render_laser(const struct NETOBJ_LASER *current)
-{
-	vec2 pos = vec2(current->x, current->y);
-	vec2 from = vec2(current->from_x, current->from_y);
-	vec2 dir = normalize(pos-from);
-
-	float ticks = client_tick() + client_intratick() - current->start_tick;
-	float ms = (ticks/50.0f) * 1000.0f;
-	float a =  ms / gameclient.tuning.laser_bounce_delay;
-	a = clamp(a, 0.0f, 1.0f);
-	float ia = 1-a;
+		vec2 out, border;
 	
-	vec2 out, border;
+		
+		// render inner beam
+		gfx_blend_normal();		
+		gfx_texture_set(-1);
 	
-	gfx_blend_normal();
-	gfx_texture_set(-1);
-	gfx_quads_begin();
+		gfx_quads_begin();		
+		// do outline
+		gfx_setcolor(1.0,1.0,0.8,1.0f);
+		out = vec2(dir.y, -dir.x) * 3;
+
+		gfx_quads_draw_freeform(
+				from.x-out.x, from.y-out.y,
+				from.x+out.x, from.y+out.y,
+				pos.x-out.x, pos.y-out.y,
+				pos.x+out.x, pos.y+out.y
+			);
+			
+		gfx_quads_end();
 	
-	//vec4 inner_color(0.15f,0.35f,0.75f,1.0f);
-	//vec4 outer_color(0.65f,0.85f,1.0f,1.0f);
-
-	// do outline
-	vec4 outer_color(0.075f,0.075f,0.25f,1.0f);
-	gfx_setcolor(outer_color.r,outer_color.g,outer_color.b,1.0f);
-	out = vec2(dir.y, -dir.x) * (7.0f*ia);
-
-	gfx_quads_draw_freeform(
-			from.x-out.x, from.y-out.y,
-			from.x+out.x, from.y+out.y,
-			pos.x-out.x, pos.y-out.y,
-			pos.x+out.x, pos.y+out.y
-		);
-
-	// do inner	
-	vec4 inner_color(0.5f,0.5f,1.0f,1.0f);
-	out = vec2(dir.y, -dir.x) * (5.0f*ia);
-	gfx_setcolor(inner_color.r, inner_color.g, inner_color.b, 1.0f); // center
-	
-	gfx_quads_draw_freeform(
-			from.x-out.x, from.y-out.y,
-			from.x+out.x, from.y+out.y,
-			pos.x-out.x, pos.y-out.y,
-			pos.x+out.x, pos.y+out.y
-		);
+	
+		// render sprites
+		gfx_blend_additive();		
+		gfx_texture_set(data->images[IMAGE_EGAME].id);		
 		
-	gfx_quads_end();
+		gfx_quads_begin();		
+		select_sprite(SPRITE_SHAFT_BEAM1);
+		gfx_setcolor(1.0,1.0,0.8,1.0f);
 	
-	// render head
+		gfx_quads_setrotation(get_angle(dir));
+	
+		float size = 15;
+		float offset = 40;
+		float move = offset - dist/2;
+		
+		gfx_quads_draw(pos.x+dir.x*move, pos.y+dir.y*move, dist - offset/2, 2*size + 10 * cos((float)client_tick()));			
+		gfx_quads_end();
+		
+		// render head
+		{
+			gfx_blend_additive();
+			gfx_texture_set(data->images[IMAGE_EGAME].id);
+			gfx_quads_begin();
+
+			gfx_setcolor(1.0,1.0,1.0,0.3f);
+			int sprites[] = {SPRITE_SHAFT_END1, SPRITE_SHAFT_END2, SPRITE_SHAFT_END3};
+			select_sprite(sprites[client_tick()%3]);
+			gfx_quads_setrotation(client_tick());
+			gfx_quads_draw(pos.x, pos.y, 50,50);
+			
+			gfx_setcolor(1.0,1.0,1.0,1.0f);
+			gfx_quads_setrotation(client_tick()*2);
+			gfx_quads_draw(pos.x, pos.y, 25,25);
+			gfx_quads_end();
+		}
+		
+		gfx_blend_normal();
+}
+
+void ITEMS::render_laser(const struct NETOBJ_LASER *current)
+{
+	if (current->type == WEAPON_RIFLE) 
 	{
+		vec2 pos = vec2(current->x, current->y);
+		vec2 from = vec2(current->from_x, current->from_y);
+		vec2 dir = normalize(pos-from);
+
+		float ticks = client_tick() + client_intratick() - current->start_tick;
+		float ms = (ticks/50.0f) * 1000.0f;
+		float a =  ms / gameclient.tuning.laser_bounce_delay;
+		a = clamp(a, 0.0f, 1.0f);
+		float ia = 1-a;
+		
+		vec2 out, border;
+		
 		gfx_blend_normal();
-		gfx_texture_set(data->images[IMAGE_PARTICLES].id);
+		gfx_texture_set(-1);
 		gfx_quads_begin();
+		
+		//vec4 inner_color(0.15f,0.35f,0.75f,1.0f);
+		//vec4 outer_color(0.65f,0.85f,1.0f,1.0f);
 
-		int sprites[] = {SPRITE_PART_SPLAT01, SPRITE_PART_SPLAT02, SPRITE_PART_SPLAT03};
-		select_sprite(sprites[client_tick()%3]);
-		gfx_quads_setrotation(client_tick());
+		// do outline
+		vec4 outer_color(0.075f,0.075f,0.25f,1.0f);
 		gfx_setcolor(outer_color.r,outer_color.g,outer_color.b,1.0f);
-		gfx_quads_draw(pos.x, pos.y, 24,24);
-		gfx_setcolor(inner_color.r, inner_color.g, inner_color.b, 1.0f);
-		gfx_quads_draw(pos.x, pos.y, 20,20);
+		out = vec2(dir.y, -dir.x) * (7.0f*ia);
+
+		gfx_quads_draw_freeform(
+				from.x-out.x, from.y-out.y,
+				from.x+out.x, from.y+out.y,
+				pos.x-out.x, pos.y-out.y,
+				pos.x+out.x, pos.y+out.y
+			);
+
+		// do inner	
+		vec4 inner_color(0.5f,0.5f,1.0f,1.0f);
+		out = vec2(dir.y, -dir.x) * (5.0f*ia);
+		gfx_setcolor(inner_color.r, inner_color.g, inner_color.b, 1.0f); // center
+		
+		gfx_quads_draw_freeform(
+				from.x-out.x, from.y-out.y,
+				from.x+out.x, from.y+out.y,
+				pos.x-out.x, pos.y-out.y,
+				pos.x+out.x, pos.y+out.y
+			);
+			
 		gfx_quads_end();
+		
+		// render head
+		{
+			gfx_blend_normal();
+			gfx_texture_set(data->images[IMAGE_PARTICLES].id);
+			gfx_quads_begin();
+
+			int sprites[] = {SPRITE_PART_SPLAT01, SPRITE_PART_SPLAT02, SPRITE_PART_SPLAT03};
+			select_sprite(sprites[client_tick()%3]);
+			gfx_quads_setrotation(client_tick());
+			gfx_setcolor(outer_color.r,outer_color.g,outer_color.b,1.0f);
+			gfx_quads_draw(pos.x, pos.y, 24,24);
+			gfx_setcolor(inner_color.r, inner_color.g, inner_color.b, 1.0f);
+			gfx_quads_draw(pos.x, pos.y, 20,20);
+			gfx_quads_end();
+		}
+		
+		gfx_blend_normal();
+	}
+	else if (current->type == WEAPON_SPINGUN)
+	{
+		render_vortex(current);
 	}
+	return;
+}
+
+void ITEMS::render_vortex(const struct NETOBJ_LASER *current)
+{
+	vec2 pos = vec2(current->x, current->y);
+	
+	float ticks = client_tick() + client_intratick() - current->start_tick;
+	float tfactor = client_tickspeed() / 1000.0f;
+	float lifespan = tfactor*VORTEX::lifespan(); // in client ticks
+	
+	float size = 120;
+	float a = (lifespan-ticks)/lifespan;
+	float shrinktresh = 0.7;
+
+	if (a<shrinktresh)
+		size = size * a / shrinktresh;
+
+	gfx_texture_set(data->images[IMAGE_EGAME].id);
+	// render halos
+	gfx_blend_additive();
+	gfx_quads_begin();
+	select_sprite(SPRITE_WEAPON_SPINGUN_HALO);		
+	gfx_setcolor(0.5, 0.5, 0.9, a/2);
+	float hs = (1-a)*20;
+	hs = hs*hs + 30;
+	
+	gfx_quads_draw(pos.x, pos.y, hs*2, hs*2);	
+	gfx_quads_end();
+	
+	gfx_quads_begin();
+	select_sprite(SPRITE_WEAPON_SPINGUN_HALO);
+	hs = (1-a)*100 + 30;	
+	
+	// render vortexes
+	gfx_blend_subtractive();	
+	
+	gfx_setcolor(0.6, 0.7, 1.0, a/4);
+	gfx_quads_draw(pos.x, pos.y, hs, hs);	
+	
+	select_sprite(SPRITE_WEAPON_SPINGUN_VORTEX);		
+	gfx_setcolor(1.0f, 1.0, 1.0, a/2);	
+	gfx_quads_setrotation(ticks/25.0);
+	gfx_quads_draw(pos.x, pos.y, size*1.5, size*1.5);
+	
+	gfx_setcolor(0.9, 0.90, 1.0, a);
+	gfx_quads_setrotation(ticks/10.0);
+	gfx_quads_draw(pos.x, pos.y, size*1.1, size*1.1);
+	
+	// render lightnings
+	gfx_quads_end();
+	gfx_blend_additive();
+	gfx_quads_begin();
+	
+	float times[] = {1, 0.95, 0.92, 0.85, 0.80};
+	int sprites[] = {SPRITE_WEAPON_SPINGUN_LIGHTNING1, SPRITE_WEAPON_SPINGUN_LIGHTNING2};
+	float ls = 0.4;
+	
+	for (int i=0; i<5; i++) {
+		if (a < times[i] - ls)
+			continue;
+		if (a > times[i])
+			break;
+		
+		select_sprite(sprites[i%2]);
+		
+		gfx_setcolor(1.0f, 1.0, 1.0, (a - (times[i]-ls))/ls);
+		float angle = i * 27 * (current->start_tick % 300); 
+		
+		vec2 dir = get_dir(angle);
+		angle = get_angle(dir);
+		gfx_quads_setrotation(angle - pi/2);
+		float s = 50;
+		gfx_quads_draw(pos.x - dir.x * s , pos.y - dir.y*s, s, s*2);
+	}
+	
+	gfx_quads_end();
+	gfx_blend_subtractive();
+	
+	gfx_quads_begin();
+	select_sprite(SPRITE_WEAPON_SPINGUN_VORTEX);
+	// rest of vortex
+	gfx_setcolor(1.0f, 1.0, 1.0, a);
+	gfx_quads_setrotation(ticks/8.0);
+	gfx_quads_draw(pos.x, pos.y, size*0.8, size*0.8);	
+	
+	gfx_setcolor(1.0f, 1.0, 1.0, a);
+	gfx_quads_setrotation(ticks/6.0);
+	gfx_quads_draw(pos.x, pos.y, size*0.6, size*0.6);
+	
+	gfx_quads_end();	
+	
+	gfx_blend_normal();
 	
-	gfx_blend_normal();	
 }
 
 void ITEMS::on_render()
@@ -225,6 +504,10 @@ void ITEMS::on_render()
 		{
 			render_projectile((const NETOBJ_PROJECTILE *)data, item.id);
 		}
+		else if(item.type == NETOBJTYPE_DROPPED_WEAPON)
+		{
+			render_DROPPEDWEAPON((const NETOBJ_DROPPED_WEAPON *)data);
+		}
 		else if(item.type == NETOBJTYPE_PICKUP)
 		{
 			const void *prev = snap_find_item(SNAP_PREV, item.type, item.id);
@@ -240,6 +523,10 @@ void ITEMS::on_render()
 			const void *prev = snap_find_item(SNAP_PREV, item.type, item.id);
 			if (prev)
 				render_flag((const NETOBJ_FLAG *)prev, (const NETOBJ_FLAG *)data);
+		} 
+		else if(item.type == NETOBJTYPE_SHAFT_BEAM)
+		{
+			render_shaft_beam((const NETOBJ_SHAFT_BEAM *)data);
 		}
 	}
 
diff -rupN d:\t052/src/game/client/components/items.hpp d:\eg/src/game/client/components/items.hpp
--- d:\t052/src/game/client/components/items.hpp	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/game/client/components/items.hpp	2010-02-04 10:53:13.000000000 +0100
@@ -3,11 +3,13 @@
 class ITEMS : public COMPONENT
 {	
 	void render_projectile(const NETOBJ_PROJECTILE *current, int itemid);
+	void render_DROPPEDWEAPON(const NETOBJ_DROPPED_WEAPON *current);
 	void render_pickup(const NETOBJ_PICKUP *prev, const NETOBJ_PICKUP *current);
 	void render_flag(const NETOBJ_FLAG *prev, const NETOBJ_FLAG *current);
 	void render_laser(const struct NETOBJ_LASER *current);
+	void render_vortex(const struct NETOBJ_LASER *current);
+	void render_shaft_beam(const struct NETOBJ_SHAFT_BEAM *current);
 	
 public:
 	virtual void on_render();
-};
-
+};
\ No newline at end of file
diff -rupN d:\t052/src/game/client/components/killmessages.cpp d:\eg/src/game/client/components/killmessages.cpp
--- d:\t052/src/game/client/components/killmessages.cpp	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/game/client/components/killmessages.cpp	2010-02-04 10:53:13.000000000 +0100
@@ -86,7 +86,11 @@ void KILLMESSAGES::on_render()
 		x -= 44.0f;
 		if (killmsgs[r].weapon >= 0)
 		{
-			gfx_texture_set(data->images[IMAGE_GAME].id);
+			if(killmsgs[r].weapon > WEAPON_RIFLE && killmsgs[r].weapon != WEAPON_NINJA)
+				gfx_texture_set(data->images[IMAGE_EGAME].id);
+			else
+				gfx_texture_set(data->images[IMAGE_GAME].id);
+				
 			gfx_quads_begin();
 			select_sprite(data->weapons.id[killmsgs[r].weapon].sprite_body);
 			draw_sprite(x, y+28, 96);
diff -rupN d:\t052/src/game/client/components/menus_settings.cpp d:\eg/src/game/client/components/menus_settings.cpp
--- d:\t052/src/game/client/components/menus_settings.cpp	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/game/client/components/menus_settings.cpp	2010-02-04 10:53:13.000000000 +0100
@@ -260,8 +260,12 @@ KEYINFO keys[] = 
 	{ "Shotgun:", "+weapon3", 0 },
 	{ "Grenade:", "+weapon4", 0 },
 	{ "Rifle:", "+weapon5", 0 },
+	{ "Shaft:", "+weapon6", 0 },
+	{ "Spin Gun:", "+weapon7", 0 },
+	{ "Biorifle:", "+weapon8", 0 },
 	{ "Next Weapon:", "+nextweapon", 0 },
 	{ "Prev. Weapon:", "+prevweapon", 0 },
+	{ "Drop Weapon:", "+dropweapon", 0 },
 	{ "Vote Yes:", "vote yes", 0 },
 	{ "Vote No:", "vote no", 0 },
 	{ "Chat:", "chat all", 0 },
@@ -271,6 +275,7 @@ KEYINFO keys[] = 
 	{ "Remote Console:", "toggle_remote_console", 0 },
 	{ "Screenshot:", "screenshot", 0 },
 	{ "Scoreboard:", "+scoreboard", 0 },
+	{ "Personal Scoreboard:", "+personal_scoreboard", 0 },
 };
 
 const int key_count = sizeof(keys) / sizeof(KEYINFO);
@@ -321,7 +326,8 @@ void MENUS::render_settings_controls(REC
 	
 	/* movement settings */
 	{
-		ui_hsplit_t(&movement_settings, main_view.h/2-5.0f, &movement_settings, &weapon_settings);
+		//ui_hsplit_t(&movement_settings, main_view.h/2-5.0f, &movement_settings, &weapon_settings);
+		ui_hsplit_t(&movement_settings, main_view.h/2-55.0f, &movement_settings, &weapon_settings);
 		ui_draw_rect(&movement_settings, vec4(1,1,1,0.25f), CORNER_ALL, 10.0f);
 		ui_margin(&movement_settings, 10.0f, &movement_settings);
 		
@@ -346,6 +352,7 @@ void MENUS::render_settings_controls(REC
 	
 	/* weapon settings */
 	{
+		//ui_hsplit_t(&weapon_settings, 10.0f, 0, &weapon_settings);
 		ui_hsplit_t(&weapon_settings, 10.0f, 0, &weapon_settings);
 		ui_draw_rect(&weapon_settings, vec4(1,1,1,0.25f), CORNER_ALL, 10.0f);
 		ui_margin(&weapon_settings, 10.0f, &weapon_settings);
@@ -353,7 +360,7 @@ void MENUS::render_settings_controls(REC
 		gfx_text(0, weapon_settings.x, weapon_settings.y, 14, "Weapon", -1);
 		
 		ui_hsplit_t(&weapon_settings, 14.0f+5.0f+10.0f, 0, &weapon_settings);
-		ui_do_getbuttons(5, 12, weapon_settings);
+		ui_do_getbuttons(5, 16, weapon_settings);
 	}
 	
 	/* voting settings */
@@ -366,7 +373,7 @@ void MENUS::render_settings_controls(REC
 		gfx_text(0, voting_settings.x, voting_settings.y, 14, "Voting", -1);
 		
 		ui_hsplit_t(&voting_settings, 14.0f+5.0f+10.0f, 0, &voting_settings);
-		ui_do_getbuttons(12, 14, voting_settings);
+		ui_do_getbuttons(16, 18, voting_settings);
 	}
 	
 	/* chat settings */
@@ -379,7 +386,7 @@ void MENUS::render_settings_controls(REC
 		gfx_text(0, chat_settings.x, chat_settings.y, 14, "Chat", -1);
 		
 		ui_hsplit_t(&chat_settings, 14.0f+5.0f+10.0f, 0, &chat_settings);
-		ui_do_getbuttons(14, 16, chat_settings);
+		ui_do_getbuttons(18, 20, chat_settings);
 	}
 	
 	/* misc settings */
@@ -392,7 +399,7 @@ void MENUS::render_settings_controls(REC
 		gfx_text(0, misc_settings.x, misc_settings.y, 14, "Miscellaneous", -1);
 		
 		ui_hsplit_t(&misc_settings, 14.0f+5.0f+10.0f, 0, &misc_settings);
-		ui_do_getbuttons(16, 21, misc_settings);
+		ui_do_getbuttons(20, 26, misc_settings);
 	}
 	
 	// defaults
diff -rupN d:\t052/src/game/client/components/players.cpp d:\eg/src/game/client/components/players.cpp
--- d:\t052/src/game/client/components/players.cpp	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/game/client/components/players.cpp	2010-02-04 10:53:13.000000000 +0100
@@ -97,6 +97,23 @@ void PLAYERS::render_player(
 	if(gameclient.snap.gameobj)
 		is_teamplay = (gameclient.snap.gameobj->flags&GAMEFLAG_TEAMS) != 0;
 
+	// check for powersuit
+	if (player.specialstate == 1 || player.specialstate == 3)
+	{
+		int skin = gameclient.skins->find("x_suit");
+		if(skin != -1)
+		{
+			if(is_teamplay)
+				render_info.texture = gameclient.skins->get(skin)->color_texture;
+			else
+			{
+				render_info.texture = gameclient.skins->get(skin)->org_texture;
+				render_info.color_body = vec4(1,1,1,1);
+				render_info.color_feet = vec4(1,1,1,1);
+			}
+		}	
+	}
+	
 	// check for ninja	
 	if (player.weapon == WEAPON_NINJA)
 	{
@@ -114,7 +131,7 @@ void PLAYERS::render_player(
 			}
 		}	
 	}
-	
+
 	// set size
 	render_info.size = 64.0f;
 
@@ -265,6 +282,10 @@ void PLAYERS::render_player(
 		// render head
 		select_sprite(SPRITE_HOOK_HEAD);
 		gfx_quads_draw(hook_pos.x, hook_pos.y, 24,16);
+		if(player.specialstate == 2 || player.specialstate == 3)
+		{
+			gameclient.effects->powerupshine(vec2(hook_pos.x, hook_pos.y), vec2(18,18));
+		}
 
 		// render chain
 		select_sprite(SPRITE_HOOK_CHAIN);
@@ -273,6 +294,11 @@ void PLAYERS::render_player(
 		{
 			vec2 p = hook_pos + dir*f;
 			gfx_quads_draw(p.x, p.y,24,16);
+			
+			if(player.specialstate == 2 || player.specialstate == 3)
+			{
+				gameclient.effects->powerupshine(vec2(p.x, p.y), vec2(18,18));
+			}
 		}
 
 		gfx_quads_setrotation(0);
@@ -283,7 +309,11 @@ void PLAYERS::render_player(
 
 	// draw gun
 	{
-		gfx_texture_set(data->images[IMAGE_GAME].id);
+		if(player.weapon > WEAPON_RIFLE && player.weapon != WEAPON_NINJA)		
+			gfx_texture_set(data->images[IMAGE_EGAME].id);
+		else 
+			gfx_texture_set(data->images[IMAGE_GAME].id);
+
 		gfx_quads_begin();
 		gfx_quads_setrotation(state.attach.angle*pi*2+angle);
 
@@ -492,3 +522,12 @@ void PLAYERS::on_render()
 		}
 	}
 }
+
+vec2 PLAYERS::get_intratick_pos(int clientID) 
+{
+	NETOBJ_CHARACTER prev_char = gameclient.snap.characters[clientID].prev;
+	NETOBJ_CHARACTER cur_char = gameclient.snap.characters[clientID].cur;
+	float intratick = client_intratick();
+	vec2 position = mix(vec2(prev_char.x, prev_char.y), vec2(cur_char.x, cur_char.y), intratick);
+	return position;
+}
\ No newline at end of file
diff -rupN d:\t052/src/game/client/components/players.hpp d:\eg/src/game/client/components/players.hpp
--- d:\t052/src/game/client/components/players.hpp	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/game/client/components/players.hpp	2010-02-04 10:53:13.000000000 +0100
@@ -12,5 +12,6 @@ class PLAYERS : public COMPONENT
 	
 public:
 	virtual void on_render();
+	static vec2 get_intratick_pos(int clientID);
 };
 
diff -rupN d:\t052/src/game/client/components/scoreboard.cpp d:\eg/src/game/client/components/scoreboard.cpp
--- d:\t052/src/game/client/components/scoreboard.cpp	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/game/client/components/scoreboard.cpp	2010-02-04 10:53:13.000000000 +0100
@@ -106,7 +106,7 @@ void SCOREBOARD::render_spectators(float
 
 void SCOREBOARD::render_scoreboard(float x, float y, float w, int team, const char *title)
 {
-	//float ystart = y;
+	float ystart = y;
 	float h = 750.0f;
 
 	gfx_blend_normal();
@@ -145,7 +145,13 @@ void SCOREBOARD::render_scoreboard(float
 		}
 	}
 
-	y += 54.0f;
+	gfx_text(0, x+w/2-70, y, 24.0f, "Avg", -1);
+	gfx_text(0, x+w/2+40, y, 24.0f, "Avg", -1);
+	y += 27.0f;
+
+	gfx_text(0, x+w/2-70, y, 24.0f, "Acc", -1);
+	gfx_text(0, x+w/2+40, y, 24.0f, "Ping", -1);
+	y += 27.0f;
 
 	// find players
 	const NETOBJ_PLAYER_INFO *players[MAX_CLIENTS] = {0};
@@ -184,6 +190,8 @@ void SCOREBOARD::render_scoreboard(float
 	gfx_text(0, x+10, y, 24.0f, "Score", -1);
 	gfx_text(0, x+125, y, 24.0f, "Name", -1);
 	gfx_text(0, x+w-70, y, 24.0f, "Ping", -1);
+	gfx_text(0, x+w-255, y, 24.0f, "Net", -1);
+	gfx_text(0, x+w-200, y, 24.0f, "Accuracy", -1);
 	y += 29.0f;
 
 	float font_size = 35.0f;
@@ -199,6 +207,8 @@ void SCOREBOARD::render_scoreboard(float
 		tee_offset = -5.0f;
 	}
 	
+	int avgping = 0;
+	int avgaccuracy = 0;
 	// render player scores
 	for(int i = 0; i < num_players; i++)
 	{
@@ -220,6 +230,12 @@ void SCOREBOARD::render_scoreboard(float
 		str_format(buf, sizeof(buf), "%4d", info->score);
 		gfx_text(0, x+60-gfx_text_width(0, font_size,buf,-1), y, font_size, buf, -1);
 		
+		str_format(buf, sizeof(buf), "%4d", info->overall_accuracy);
+		gfx_text(0, x+w-140-gfx_text_width(0, font_size,buf,-1), y, font_size, buf, -1);
+		
+		str_format(buf, sizeof(buf), "%4d", info->netscore);
+		gfx_text(0, x+w-225-gfx_text_width(0, font_size,buf,-1), y, font_size, buf, -1);
+		
 		gfx_text(0, x+128, y, font_size, gameclient.clients[info->cid].name, -1);
 
 		str_format(buf, sizeof(buf), "%4d", info->latency);
@@ -246,9 +262,25 @@ void SCOREBOARD::render_scoreboard(float
 		teeinfo.size *= tee_sizemod;
 		render_tee(ANIMSTATE::get_idle(), &teeinfo, EMOTE_NORMAL, vec2(1,0), vec2(x+90, y+28+tee_offset));
 
+		avgping += info->latency;
+		avgaccuracy += info->overall_accuracy;
 		
 		y += line_height;
 	}
+	if(num_players > 1)
+	{
+		avgping = avgping / num_players;
+		avgaccuracy = avgaccuracy / (num_players + 1);
+	}
+	
+	char buf[128];
+	str_format(buf, sizeof(buf), "%d", avgping);
+	tw = gfx_text_width(0, 48, buf, -1);
+	gfx_text(0, x+w-tw-170, ystart, 48, buf, -1);
+	
+	str_format(buf, sizeof(buf), "%d", avgaccuracy);
+	tw = gfx_text_width(0, 48, buf, -1);
+	gfx_text(0, x+w-tw-300, ystart, 48, buf, -1);
 }
 
 void SCOREBOARD::on_render()
@@ -261,7 +293,7 @@ void SCOREBOARD::on_render()
 		
 	if(gameclient.snap.local_info && gameclient.snap.local_info->team != -1)
 	{
-		// we are not a spectator, check if we are ead
+		// we are not a spectator, check if we are dead
 		if(!gameclient.snap.local_character || gameclient.snap.local_character->health < 0)
 			do_scoreboard = true;
 	}
diff -rupN d:\t052/src/game/client/gameclient.cpp d:\eg/src/game/client/gameclient.cpp
--- d:\t052/src/game/client/gameclient.cpp	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/game/client/gameclient.cpp	2010-02-04 10:53:13.000000000 +0100
@@ -504,6 +504,11 @@ void GAMECLIENT::process_events()
 			NETEVENT_HAMMERHIT *ev = (NETEVENT_HAMMERHIT *)data;
 			gameclient.effects->hammerhit(vec2(ev->x, ev->y));
 		}
+		else if(item.type == NETEVENTTYPE_BIOSPLASH)
+		{
+			NETEVENT_BIOSPLASH *ev = (NETEVENT_BIOSPLASH *)data;
+			gameclient.effects->biosplash(vec2(ev->x, ev->y), ev->playSound);
+		}
 		else if(item.type == NETEVENTTYPE_SPAWN)
 		{
 			NETEVENT_SPAWN *ev = (NETEVENT_SPAWN *)data;
diff -rupN d:\t052/src/game/collision.cpp d:\eg/src/game/collision.cpp
--- d:\t052/src/game/collision.cpp	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/game/collision.cpp	2010-02-04 10:53:13.000000000 +0100
@@ -12,6 +12,10 @@
 static TILE *tiles;
 static int width = 0;
 static int height = 0;
+//tele
+static int *dest[42];
+static int len[42];
+static int tele[42];
 
 int col_width() { return width; }
 int col_height() { return height; }
@@ -22,6 +26,31 @@ int col_init()
 	height = layers_game_layer()->height;
 	tiles = (TILE *)map_get_data(layers_game_layer()->data);
 	
+// more tele
+	mem_zero(&len, sizeof(len));
+	mem_zero(&tele, sizeof(tele));
+	for(int i = width*height-1; i >= 0; i--)
+	{
+		if(tiles[i].index > 34 && tiles[i].index < 85)
+		{
+			if(tiles[i].index&1)
+				len[tiles[i].index >> 1]++;
+			else if(!(tiles[i].index&1))
+				tele[(tiles[i].index-1) >> 1]++;
+		}
+	}
+	for(int i = 0; i < 42; i++)
+	{
+		dest[i] = new int[len[i]];
+		len[i] = 0;
+	}
+	for(int i = width*height-1; i >= 0; i--)
+	{
+		if(tiles[i].index&1 && tiles[i].index > 34 && tiles[i].index < 85)
+			dest[tiles[i].index>>1][len[tiles[i].index>>1]++] = i;
+	}
+
+	
 	for(int i = 0; i < width*height; i++)
 	{
 		int index = tiles[i].index;
@@ -36,7 +65,7 @@ int col_init()
 		else if(index == TILE_NOHOOK)
 			tiles[i].index = COLFLAG_SOLID|COLFLAG_NOHOOK;
 		else
-			tiles[i].index = 0;
+			tiles[i].index = index;
 	}
 				
 	return 1;
@@ -50,7 +79,10 @@ int col_get(int x, int y)
 	
 	if(tiles[ny*width+nx].index > 128)
 		return 0;
-	return tiles[ny*width+nx].index;
+	if(tiles[ny*width+nx].index == COLFLAG_SOLID || tiles[ny*width+nx].index == (COLFLAG_SOLID|COLFLAG_NOHOOK) || tiles[ny*width+nx].index == COLFLAG_DEATH)
+		return tiles[ny*width+nx].index;
+	else
+		return 0;
 }
 
 int col_is_solid(int x, int y)
@@ -58,6 +90,42 @@ int col_is_solid(int x, int y)
 	return col_get(x,y)&COLFLAG_SOLID;
 }
 
+//even more tele
+int col_is_teleport(int x, int y)
+{
+	int nx = x/32;
+	int ny = y/32;
+	if(y < 0 || nx < 0 || nx >= width || ny >= height)
+		return 0;
+	
+	int z = tiles[ny*width+nx].index-1;
+	if(z > 34 && z < 85 && z&1)
+		return z>>1;
+	return 0;
+}
+
+int col_get_index(int x, int y)
+{
+	int nx = x/32;
+	int ny = y/32;
+	if(y<0 || nx < 0 || nx >= width || ny >= height)
+		return 0;
+	
+	return tiles[ny*width+nx].index;
+}
+
+vec2 teleport(int z)
+{
+	if(len[z] > 0)
+	{
+		int r = rand()%len[z];
+		int x = (dest[z][r]%width)<<5;
+		int y = (dest[z][r]/width)<<5;
+		return vec2((float)x+16.0, (float)y+16.0);
+	}
+	else
+		return vec2(0,0);
+}
 
 // TODO: rewrite this smarter!
 int col_intersect_line(vec2 pos0, vec2 pos1, vec2 *out_collision, vec2 *out_before_collision)
diff -rupN d:\t052/src/game/collision.hpp d:\eg/src/game/collision.hpp
--- d:\t052/src/game/collision.hpp	2009-10-26 19:04:30.000000000 +0100
+++ d:\eg/src/game/collision.hpp	2010-02-04 10:53:13.000000000 +0100
@@ -9,10 +9,14 @@ enum
 	COLFLAG_SOLID=1,
 	COLFLAG_DEATH=2,
 	COLFLAG_NOHOOK=4,
+	COLFLAG_TELE=7,
 };
 
 int col_init();
 int col_is_solid(int x, int y);
+int col_is_teleport(int x, int y);
+int col_get_index(int x, int y);
+vec2 teleport(int z);
 int col_get(int x, int y);
 int col_width();
 int col_height();
